#ifndef __DISKRENDER_H
#define __DISKRENDER_H

#include "volumeshop.h"
#include "Renderer.h"
#include "Environment.h"
#include "Shader.h"
#include "Plane.h"

class DiskRender : public Renderer {
	public:
		
		DiskRender(Environment & envEnvironment);

		virtual ~DiskRender();

		virtual void idle();

		virtual void underlay();

		virtual void display();

		virtual void overlay();

		virtual void reshape(const unsigned int uWidth, const unsigned int uHeight);

		virtual void mousePress(const MouseEvent & mouEvent);

		virtual void mouseRelease(const MouseEvent & mouEvent);

		virtual void mouseMove(const MouseEvent & mouEvent);

		virtual void keyboardPress(const KeyboardEvent & keyEvent);

		virtual void keyboardRelease(const KeyboardEvent & keyEvent);

		void setFocus(int q, bool b);

		Vector * getTextureCoords(int q);

	private:

		Environment & m_envEnvironment;

		float m_fXY[2],m_fXZ[2],m_fYZ[2];

		float m_fZPlane,m_fRotX, m_fRotY;

		Plane m_pPlane[4];

		Vector m_vStart, m_vOld;

		Vector m_vTexCoords[4][4];

		int m_iQuadrant,m_iOldQuadrant;

		bool m_bButton0, m_bButton2, m_bFocus;

		Program m_shaderProgram;

		int GetPlane(Vector mousePos);

		void updatePosition();

		void Rotate(double degrees, int direction, Vector * v);

		void matrixMul(double matrix[][3], Vector * v);

		Vector * genTexXY(Vector * texCoord);

		Vector * genTexXZ(Vector * texCoord);

		Vector * genTexYZ(Vector * texCoord);

		Vector * genTexARB(Vector * texCoord);

		void renderBorder();

};
#endif

